# IPSupervisor common subroutines package
#
# daniel, 2014-05-06

package ipsupervisor;
use Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(&send_nsca &round &check_drbd &read_config
             $nagios_hostname $nagios_hostname_ha $nsca_host $debug $snmp_timeout);

$debug = 0;
$snmp_timeout = 5;
$nsca_host = "";
$nagios_hostname = "";
$nagios_hostname_ha = "";
1;

sub send_nsca {
    my ($line,$host) = @_;
    open(NSCA, "|/usr/sbin/send_nsca -H $host -d \\| -c /etc/nagios/send_nsca.cfg -p 80") || die "Error al abrir pipe!\n"; 
    print NSCA $line;
    print "send_nsca: $line\n" if $debug;
    close NSCA;
}

sub round {
    my $float = shift;
    return int($float + $float/abs($float*2));
}

# Check for DRBD active
# Returns:
# -1 if no DRBD config
#  1 if DRBD, and host is primary
#  0 if DRBD, and host is not primary
sub check_drbd {
    my $res = -1;
    if (-r '/proc/drbd' ) {
	my $drbd = `cat /proc/drbd | grep "cs:"`;
	my $ro = $1 if $drbd =~ /cs\:\w+ ro\:(\w+)\/\w+ ds:\w+\/\w+/;
	# Returns 1 if primary, 0 otherwise
	$res = ($ro eq 'Primary');
    }
    return $res;
}


sub read_config {
    open(CONFIG, "/etc/nagios/ipsupervisor.conf") || warn "/etc/nagios/ipsupervisor.conf doesn't exists!\n";
    while ($line = <CONFIG>) {
	next if ($line =~ /^\s*\#\w*/);
	$nagios_hostname = $1 if ($line =~ /^\s*nagios_hostname\s*=\s*(\w+)/);
	$nagios_hostname_ha = $1 if ($line =~ /^\s*nagios_hostname_ha\s*=\s*(\w+)/);
	$nsca_host = $1 if ($line =~ /^\s*nsca_host\s*=\s*([\w.]+)/);
    }
    #print "Read from config: nsca_host: $nsca_host, nagios_hostname: $nagios_hostname\n";
    close CONFIG;
}
